{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,R-,S-,V-,X-}

Unit Graph3rd;               {Graph3rd.Pas}

{~~~~~~~~~~ INTERFACE SECTION ~~~~~~~~~~}
 Interface

{  樥⮢ ⠡஢ }
  Procedure cmSetMinX        (X : Real);
  Procedure cmSetMinY        (Y : Real);
  Procedure cmSetMinZ        (Z : Real);
  Procedure cmSetMaxX        (X : Real);
  Procedure cmSetMaxY        (Y : Real);
  Procedure cmSetMaxZ        (Z : Real);
  Function cmGetMinX         : Real;
  Function cmGetMinY         : Real;
  Function cmGetMinZ         : Real;
  Function cmGetMaxX         : Real;
  Function cmGetMaxY         : Real;
  Function cmGetMaxZ         : Real;

{----   ࠢ ஥樨 ----}
  Procedure cmSetDirectVector          (VX, VY, VZ : Real);
  Procedure cmGetDirectVector          (Var VX, VY, VZ : Real);

{-- 襭 (ࠡ⠥,   ) --}
  Procedure cmRotateYZ       (Angle : Real);
  Procedure cmRotateXZ       (Angle : Real);
  Procedure cmRotateXY       (Angle : Real);

{------ ८ࠧ  न ------}
  Procedure cm3rdTo2nd       (X3rd, Y3rd, Z3rd : Real; Var X2nd, Y2nd : Integer);

{-------- ᮢ  ਬ⨢ --------}
  Procedure cmLine3rd        (X1, Y1, Z1, X2, Y2, Z2 : Real);
  Procedure cmLineTo3rd      (X, Y, Z : Real);
  Procedure cmMoveTo3rd      (X, Y, Z : Real);
  Procedure cmPutPixel3rd    (X, Y, Z : Real; Pixel : Word);


{~~~~~~~~~~ IMPLEMENTATION SECTION ~~~~~~~~~~}
 Implementation

  Uses
    Graph;

  Type
    tMatrix3x1               = Array ['X'..'Z'] Of Real;
    tMatrix3x2               = Array ['X'..'Z', 'X'..'Y'] Of Real;
    tMatrix3x3               = Array ['X'..'Z', 'X'..'Z'] Of Real;

  Var
   cmTransferMatrix                    : tMatrix3x3;
   cmDirectVector                      : tMatrix3x1;
   cmMinX, cmMinY, cmMinZ,
   cmMaxX, cmMaxY, cmMaxZ,
   cmDX, cmDY, cmDZ,
   cmKx, cmKy                          : Real;
   cmMxx, cmMxy, cmMyy, cmMyz,
   cmAx, cmAy                          : Integer;

  Function Sign (N : Real)   : Integer;
   Begin
    If N = 0
    Then
      Sign                   := 0
    Else
     If N > 0
     Then
       Sign                  := 1
     Else
       Sign                  := -1;
   End;

  Procedure MultiplyMatrix3x3          (M1, M2 : tMatrix3x3; Var RM : tMatrix3x3);
   Var
     I, J, K                 : Char;
   Begin
    For I := 'X' To 'Z' Do
     For J := 'X' To 'Z' Do
     Begin
       RM [I, J]             := 0;
      For K := 'X' To 'Z' Do
        RM [I, J]            := RM [I, J] + M1 [I, K] * M2 [K, J];
     End;
   End;

  Procedure cmSetMinX        (X : Real);
   Begin
     cmMinX                  := X;
     cmDX                    := cmMaxX - cmMinX;
   End;

  Procedure cmSetMinY        (Y : Real);
   Begin
     cmMinY                  := Y;
     cmDY                    := cmMaxY - cmMinY;
   End;

  Procedure cmSetMinZ        (Z : Real);
   Begin
     cmMinZ                  := Z;
     cmDZ                    := cmMaxZ - cmMinZ;
   End;

  Procedure cmSetMaxX        (X : Real);
   Begin
     cmMaxX                  := X;
     cmDX                    := cmMaxX - cmMinX;
   End;

  Procedure cmSetMaxY        (Y : Real);
   Begin
     cmMaxY                  := Y;
     cmDY                    := cmMaxY - cmMinY;
   End;

  Procedure cmSetMaxZ        (Z : Real);
   Begin
     cmMaxZ                  := Z;
     cmDZ                    := cmMaxZ - cmMinZ;
   End;

  Function cmGetMinX         : Real;
   Begin
     cmGetMinX               := cmMinX;
   End;

  Function cmGetMinY         : Real;
   Begin
     cmGetMinY               := cmMinY;
   End;

  Function cmGetMinZ         : Real;
   Begin
     cmGetMinZ               := cmMinZ;
   End;

  Function cmGetMaxX         : Real;
   Begin
     cmGetMaxX               := cmMaxX;
   End;

  Function cmGetMaxY         : Real;
   Begin
     cmGetMaxY               := cmMaxY;
   End;

  Function cmGetMaxZ         : Real;
   Begin
     cmGetMaxZ               := cmMaxZ;
   End;

  Procedure cmSetDirectVector          (Vx, Vy, Vz : Real);
   Var
     MaxX, MaxY              : Integer;
   Begin
    If Vy = 0
    Then
      Exit;
     cmDirectVector ['X']    := Vx;
     cmDirectVector ['Y']    := Vy;
     cmDirectVector ['Z']    := Vz;
    If cmDirectVector ['Y'] > 0
    Then Begin
           cmDirectVector ['X']        := - cmDirectVector['X'];
           cmDirectVector ['Y']        := - cmDirectVector['Y'];
           cmDirectVector ['Z']        := - cmDirectVector['Z'];
         End;
     cmKx                    := Vx / Vy;
     cmKy                    := Vz / Vy;
     MaxX                    := GetMaxX Div 2;
     MaxY                    := GetMaxY Div 2;
     cmMxx                   := Round (MaxX / (1 + Abs(cmKx)));
     cmMxy                   := (cmMxx - MaxX) * Sign(cmKx);
     cmMyz                   := Round (MaxY / (1 + Abs(cmKy)));
     cmMyy                   := (cmMyz - MaxY) * Sign(cmKy);
     cmAx                    := MaxX - cmMxx + cmMxy;
     cmAy                    := MaxY - cmMyy + cmMyz;
     cmMxx                   := cmMxx * 2;
     cmMxy                   := cmMxy * 2;
     cmMyy                   := cmMyy * 2;
     cmMyz                   := cmMyz * 2;
   End;

  Procedure cmGetDirectVector          (Var Vx, Vy, Vz : Real);
   Begin
     Vx                      := cmDirectVector ['X'];
     Vy                      := cmDirectVector ['Y'];
     Vz                      := cmDirectVector ['Z'];
   End;

  Procedure cmRotateYZ       (Angle : Real);
   Var
     MM, RM                  : tMatrix3x3;
   Begin
     MM ['X', 'X']           := 1;
     MM ['X', 'Y']           := 0;
     MM ['X', 'Z']           := 0;
     MM ['Y', 'X']           := 0;
     MM ['Y', 'Y']           := Cos (Angle);
     MM ['Y', 'Z']           := Sin (Angle);
     MM ['Z', 'X']           := 0;
     MM ['Z', 'Y']           := - Sin (Angle);
     MM ['Z', 'Z']           := Cos (Angle);
     MultiplyMatrix3x3       (MM, cmTransferMatrix, RM);
     cmTransferMatrix        := RM;
   End;

  Procedure cmRotateXZ       (Angle : Real);
   Var
     MM, RM                  : tMatrix3x3;
   Begin
     MM ['X', 'X']           := Cos (Angle);
     MM ['X', 'Y']           := 0;
     MM ['X', 'Z']           := Sin (Angle);
     MM ['Y', 'X']           := 0;
     MM ['Y', 'Y']           := 1;
     MM ['Y', 'Z']           := 0;
     MM ['Z', 'X']           := - Sin (Angle);
     MM ['Z', 'Y']           := 0;
     MM ['Z', 'Z']           := Cos (Angle);
     MultiplyMatrix3x3       (MM, cmTransferMatrix, RM);
     cmTransferMatrix        := RM;
   End;

  Procedure cmRotateXY       (Angle : Real);
   Var
     MM, RM                  : tMatrix3x3;
   Begin
     MM ['X', 'X']           := Cos (Angle);
     MM ['X', 'Y']           := Sin (Angle);
     MM ['X', 'Z']           := 0;
     MM ['Y', 'X']           := - Sin (Angle);
     MM ['Y', 'Y']           := Cos (Angle);
     MM ['Y', 'Z']           := 0;
     MM ['Z', 'X']           := 0;
     MM ['Z', 'Y']           := 0;
     MM ['Z', 'Z']           := 1;
     MultiplyMatrix3x3       (MM, cmTransferMatrix, RM);
     cmTransferMatrix        := RM;
   End;

  Procedure cm3rdTo2nd       (X3rd, Y3rd, Z3rd : Real; Var X2nd, Y2nd : Integer);
   Var
     MM, RM                  : tMatrix3x1;
     I, J                    : Char;
   Begin
     MM ['X']                := X3rd;
     MM ['Y']                := Y3rd;
     MM ['Z']                := Z3rd;
     FillChar                (RM, SizeOf(MM), 0);
    For I := 'X' To 'Z' Do
     For J := 'X' To 'Z' Do
       RM [I]                := RM [I] + cmTransferMatrix [I, J] * MM [J];
     X2nd                    := Round ((RM['X']-cmMinX)*cmMxx/cmDX-(RM['Y']-cmMinY)*cmMxy/cmDY) + cmAx;
     Y2nd                    := Round ((RM['Y']-cmMinY)*cmMyy/cmDY-(RM['Z']-cmMinZ)*cmMyz/cmDZ) + cmAy;
   End;

  Procedure cmLine3rd        (X1, Y1, Z1, X2, Y2, Z2 : Real);
   Var
     SX1, SX2, SY1, SY2      : Integer;
   Begin
     cm3rdTo2nd              (X1, Y1, Z1, SX1, SY1);
     cm3rdTo2nd              (X2, Y2, Z2, SX2, SY2);
     Line                    (SX1, SY1, SX2, SY2);
   End;

  Procedure cmLineTo3rd      (X, Y, Z : Real);
   Var
     SX1, SY1                : Integer;
   Begin
     cm3rdTo2nd              (X, Y, Z, SX1, SY1);
     LineTo                  (SX1, SY1);
   End;

  Procedure cmMoveTo3rd      (X, Y, Z : Real);
   Var
     SX1, SY1                : Integer;
   Begin
     cm3rdTo2nd              (X, Y, Z, SX1, SY1);
     MoveTo                  (SX1, SY1);
   End;

  Procedure cmPutPixel3rd    (X, Y, Z : Real; Pixel : Word);
   Var
     SX1, SY1                : Integer;
   Begin
     cm3rdTo2nd              (X, Y, Z, SX1, SY1);
     PutPixel                (SX1, SY1, Pixel);
   End;

 Begin

   cmMinX                              := -1;
   cmMinY                              := -1;
   cmMinZ                              := -1;
   cmSetMaxX                           (1);
   cmSetMaxY                           (1);
   cmSetMaxZ                           (1);
   cmDirectVector ['X']                := 1;
   cmDirectVector ['Y']                := 1;
   cmDirectVector ['Z']                := 1;
   cmMxx                               := 320;
   cmMxy                               := -320;
   cmMyy                               := -100;
   cmMyz                               := 100;
   cmAx                                := 0;
   cmAy                                := 200;
   cmTransferMatrix ['X', 'X']         := 1;
   cmTransferMatrix ['X', 'Y']         := 0;
   cmTransferMatrix ['X', 'Z']         := 0;
   cmTransferMatrix ['Y', 'X']         := 0;
   cmTransferMatrix ['Y', 'Y']         := 1;
   cmTransferMatrix ['Y', 'Z']         := 0;
   cmTransferMatrix ['Z', 'X']         := 0;
   cmTransferMatrix ['Z', 'Y']         := 0;
   cmTransferMatrix ['Z', 'Z']         := 1;

 End.